package ru.dbotthepony.kstarbound.defs.item.impl

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.RegistryReference
import ru.dbotthepony.kstarbound.defs.ThingDescription
import ru.dbotthepony.kstarbound.defs.item.IInventoryIcon
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.defs.item.InventoryIcon
import ru.dbotthepony.kstarbound.defs.item.ItemRarity
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonFlat

@JsonFactory(logMisses = false)
data class ItemDefinition(
	@JsonFlat
	val descriptionData: ThingDescription,

	override val itemName: String,
	override val price: Long = 0,
	override val rarity: ItemRarity = ItemRarity.COMMON,
	override val category: String? = null,
	override val inventoryIcon: ImmutableList<IInventoryIcon>? = null,
	override val itemTags: ImmutableList<String> = ImmutableList.of(),
	override val learnBlueprintsOnPickup: ImmutableList<RegistryReference<IItemDefinition>> = ImmutableList.of(),
	override val maxStack: Long = 9999L,
	override val eventCategory: String? = null,
	override val consumeOnPickup: Boolean = false,
	override val pickupQuestTemplates: ImmutableList<String> = ImmutableList.of(),
	override val tooltipKind: String = "normal",
	override val twoHanded: Boolean = false,
	override val radioMessagesOnPickup: ImmutableList<String> = ImmutableList.of(),
	override val fuelAmount: Long = 0,
	override val pickupSoundsSmall: ImmutableList<String> = ImmutableList.of(),
	override val pickupSoundsMedium: ImmutableList<String> = ImmutableList.of(),
	override val pickupSoundsLarge: ImmutableList<String> = ImmutableList.of(),
	override val smallStackLimit: Long? = null,
	override val mediumStackLimit: Long? = null,
) : IItemDefinition, IThingWithDescription by descriptionData
